Skip to main content

Initializers


scopeRequired

  • Type: software.constructs.Construct

bucketRequired

  • Type: java.lang.String
(Required) The name of the GCS bucket. This name must be globally unique.

accessTokenOptional

  • Type: java.lang.String
(Optional) A temporary [OAuth 2.0 access token] obtained from the Google Authorization server, i.e. the Authorization: Bearer token used to authenticate HTTP requests to GCP APIs. This is an alternative to credentials. If both are specified, access_token will be used over the credentials field.

credentialsOptional

  • Type: java.lang.String
(Optional) Local path to Google Cloud Platform account credentials in JSON format. If unset, Google Application Default Credentials are used. The provided credentials must have Storage Object Admin role on the bucket. Warning: if using the Google Cloud Platform provider as well, it will also pick up the GOOGLE_CREDENTIALS environment variable.

encryptionKeyOptional

  • Type: java.lang.String
(Optional) A 32 byte base64 encoded ‘customer supplied encryption key’ used to encrypt all state.

impersonateServiceAccountOptional

  • Type: java.lang.String
(Optional) The service account to impersonate for accessing the State Bucket. You must have roles/iam.serviceAccountTokenCreator role on that account for the impersonation to succeed. If you are using a delegation chain, you can specify that using the impersonate_service_account_delegates field. Alternatively, this can be specified using the GOOGLE_IMPERSONATE_SERVICE_ACCOUNT environment variable.

impersonateServiceAccountDelegatesOptional

  • Type: java.util.List< java.lang.String >
(Optional) The delegation chain for an impersonating a service account.

kmsEncryptionKeyOptional

  • Type: java.lang.String
(Optional) A Cloud KMS key (‘customer-managed encryption key’) used when reading and writing state files in the bucket. Format should be projects/{{project}}/locations/{{location}}/keyRings/{{keyRing}}/cryptoKeys/{{name}}. For more information, including IAM requirements, see Customer-managed Encryption Keys.

prefixOptional

  • Type: java.lang.String
(Optional) GCS prefix inside the bucket. Named states for workspaces are stored in an object called < prefix >/< name >.tfstate.

storeageCustomEndpointOptional

  • Type: java.lang.String
(Optional) A URL containing three parts: the protocol, the DNS name pointing to a Private Service Connect endpoint, and the path for the Cloud Storage API (/storage/v1/b). See here for more details

Methods


toString

Returns a string representation of this construct.

with

Applies one or more mixins to this construct. Mixins are applied in order. The list of constructs is captured at the start of the call, so constructs added by a mixin will not be visited. Use multiple with() calls if subsequent mixins should apply to added constructs.

mixinsRequired

  • Type: software.constructs.IMixin…
The mixins to apply.

addOverride

pathRequired

  • Type: java.lang.String

valueRequired

  • Type: java.lang.Object

overrideLogicalId

Overrides the auto-generated logical ID with a specific ID.

newLogicalIdRequired

  • Type: java.lang.String
The new logical ID to use for this stack element.

resetOverrideLogicalId

Resets a previously passed logical Id to use the auto-generated logical id again.

toHclTerraform

toMetadata

toTerraform

Adds this resource to the terraform JSON output.

getRemoteStateDataSource

Creates a TerraformRemoteState resource that accesses this backend.

scopeRequired

  • Type: software.constructs.Construct

nameRequired

  • Type: java.lang.String

_fromStackRequired

  • Type: java.lang.String

Static Functions


isConstruct

Checks if x is a construct. Use this method instead of instanceof to properly detect Construct instances, even when the construct library is symlinked. Explanation: in JavaScript, multiple copies of the constructs library on disk are seen as independent, completely different libraries. As a consequence, the class Construct in each copy of the constructs library is seen as a different class, and an instance of one class will not test as instanceof the other class. npm install will not create installations like this, but users may manually symlink construct libraries together or use a monorepo tool: in those cases, multiple copies of the constructs library can be accidentally installed, and instanceof will behave unpredictably. It is safest to avoid using instanceof, and using this type-testing method instead.

xRequired

  • Type: java.lang.Object
Any object.

isTerraformElement

xRequired

  • Type: java.lang.Object

isBackend

xRequired

  • Type: java.lang.Object

Properties


nodeRequired

  • Type: software.constructs.Node
The tree node.

cdktfStackRequired


fqnRequired

  • Type: java.lang.String

friendlyUniqueIdRequired

  • Type: java.lang.String